%define mpiimpl openmpi
%define mpidir %_libexecdir/%mpiimpl

%define oname slepc4py
%define scalar_type complex
%define ldir %_libexecdir/petsc-%scalar_type

Name: %oname-%scalar_type
Version: 1.0.0
Release: alt4
Summary: SLEPc for Python (%scalar_type scalars)
License: Public
Group: Sciences/Mathematics
Url: http://slepc4py.googlecode.com/
Packager: Eugeny A. Rostovtsev (REAL) <real at altlinux.org>

Source: http://slepc4py.googlecode.com/files/slepc4py-1.0.0.tar.gz

Requires: python-module-%name = %version-%release
BuildRequires(pre): rpm-build-python
BuildPreReq: python-devel
BuildPreReq: %mpiimpl-devel libslepc-%scalar_type-devel python-module-mpi4py
BuildPreReq: python-module-numpy python-module-petsc4py-%scalar_type

%description
slepc4py are Python bindings for SLEPc, the Scalable Library for Eigenvalue
Problem Computations.

%package -n python-module-%name
Summary: Python module of SLEPc for Python (%scalar_type scalars)
Group: Development/Python
%setup_python_module %oname
Provides: python%__python_version(%oname) = %version-%release
%py_provides %oname
Requires: libslepc-%scalar_type python-module-petsc4py-%scalar_type
Requires: python-module-mpi4py

%description -n python-module-%name
slepc4py are Python bindings for SLEPc, the Scalable Library for Eigenvalue
Problem Computations.

This package contains Python module of SLEPc for Python
(%scalar_type scalars).

%package -n %oname-doc
Summary: Documentation for SLEPc for Python
Group: Development/Documentation
BuildArch: noarch

%description -n %oname-doc
slepc4py are Python bindings for SLEPc, the Scalable Library for Eigenvalue
Problem Computations.

This package contains documentation for SLEPc for Python.

%package -n %oname-examples
Summary: Examples for SLEPc for Python
Group: Development/Documentation
BuildArch: noarch

%description -n %oname-examples
slepc4py are Python bindings for SLEPc, the Scalable Library for Eigenvalue
Problem Computations.

This package contains examples for SLEPc for Python.

%prep
%setup

%build
mpi-selector --set %mpiimpl
source %_bindir/petsc-%scalar_type.sh

%python_build

TOPDIR=$PWD
pushd %mpidir/lib/%mpiimpl
for i in $(ls *.so |sed -e 's/\.so//'); do
	ln -s %mpidir/lib/%mpiimpl/$i.so $TOPDIR/lib$i.so
	MCAS="$MCAS -l$i"
done
popd
mpicxx -pthread -shared build/temp.*/linux-gnu/src/SLEPc.o \
	-L%ldir/lib -lslepc $(pkg-config petsc-%scalar_type --libs) \
	-Wl,--no-as-needed \
	-L$PWD -Wl,-R%mpidir/lib/%mpiimpl $MCAS -lopen-pal \
	-lpython%__python_version \
	-o build/lib.*/slepc4py/lib/linux-gnu/SLEPc.so

%install
source %_bindir/petsc-%scalar_type.sh
%python_install --optimize=2

install -d %buildroot%ldir/python
mv %buildroot%python_sitelibdir/* %buildroot%ldir/python/

install -d %buildroot%_docdir/%oname-%version/examples
install -p -m644 docs/slepc4py.pdf \
	%buildroot%_docdir/%oname-%version
cp -fR docs/html %buildroot%_docdir/%oname-%version/
install -p -m644 demo/* \
	%buildroot%_docdir/%oname-%version/examples

ln -s linux-gnu/SLEPc.so %buildroot%ldir/python/%oname/lib/

%files
%doc HISTORY.txt LICENSE.txt PKG-INFO

%files -n python-module-%name
%dir %ldir/python
%ldir/python/*

%if "%scalar_type" == "real"
%files -n %oname-doc
%doc %dir %_docdir/%oname-%version
%doc %_docdir/%oname-%version/html
%doc %_docdir/%oname-%version/*.pdf

%files -n %oname-examples
%doc %dir %_docdir/%oname-%version
%doc %_docdir/%oname-%version/examples
%endif

%changelog
* Thu Sep 10 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 1.0.0-alt4
- Rebuild with SLEPc-3.0.0_p5-alt1

* Tue Aug 18 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 1.0.0-alt3
- Rebuild with SLEPc-3.0.0_p4-alt3

* Thu Jul 23 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 1.0.0-alt2
- Rebuild with python 2.6

* Sun Jul 19 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 1.0.0-alt1.1
- Fixed linking of python library

* Sat Jul 18 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 1.0.0-alt1
- Initial build for Sisyphus
